;:::::::: FONCTIONS DE RECHERCHE ::::::::

; Renvoyer les cubes présents sur le terrain de construction
(defun presents (LC LP)
  (cond ((null LC)       LP)
        ((cadr (car LC)) (presents (cdr LC) (cons (caar LC) LP)))
	(t               (presents (cdr LC) LP))))

; Renvoyer les cubes absents du terrain de construction (en zone de stockage)
(defun absents (LC LP)
  (cond ((null LC)       LP)
        ((cadr (car LC)) (absents (cdr LC) LP))
	(t               (absents (cdr LC) (cons (caar LC) LP)))))

; Donner le nom du cube placé en x,y,z
(defun donnercube (abs ord hau)
  (car (nettoievide (mapcar '(lambda
			       (cube)
			       (if (and (= (accesg cube 'x) abs) (= (accesg cube 'y) ord) (= (accesg cube 'z) hau))
				   (accesg cube 'nom)
				 'vide))
			    (mapcar 'car cubes)))))

; Lister les hauteurs des cubes placés à la même abscisse et la même ordonnée
(defun listerz (abs ord)
  (nettoievide (mapcar '(lambda
			  (cube)
			  (if (and (= (accesg cube 'x) abs) (= (accesg cube 'y) ord))
			      (accesg cube 'z)
			    'vide))
		       (mapcar 'car cubes))))
 
; Rechercher la hauteur la plus grande d'une A-Liste avec les cubes et leurs hauteur
; ATTENTION, initialiser max à -1
(defun maxz (LZ max)
  (cond ((null LZ) max)
	((>= (car LZ) max) (maxz (cdr LZ) (car LZ)))
	(t                 (maxz (cdr LZ) max))))

; Lister les voisins d'un cube donné
(defun voisins (cube)
  (nettoievide (mapcar '(lambda (x) (accesg cube x)) '(nord sud ouest est haut bas))))

; Lister les cubes au même niveau qu'un cube donné
(defun memeniv (cube)
  (nettoievide (mapcar '(lambda (x) (accesg cube x)) '(nord sud ouest est))))
